// (c) Strasil 2006

#include <avr/io.h>
#include <util/delay.h>

#include "leddisplay.h"
#include "delay.h"

unsigned char muxpos=0;
unsigned char dotpos=255;

void LedSetDotPos(unsigned char dot) {
	dotpos=dot;
}



//nastaveni I/O je v zdroji v techto procesurach
void LedSwCharOn(void) {
 if (muxpos==0) {
	PORTC&=~(1<<3);
 }
 if (muxpos==1) {
	PORTC&=~(1<<1);
 }
 if (muxpos==2) {
	PORTA&=~(1<<1);
 }
 if (muxpos==3) {
	PORTB&=~(1<<1);
 }
 if (muxpos==4) {
	PORTA&=~(1<<0);
 }
 if (muxpos==5) {
	PORTD&=~(1<<5);
 }
}



void LedSwCharOff(void) {
 //PORTB|=/*((1<<7)|(1<<1)|(1<<6))*/0xFF;
 //PORTC|=/*((1<<1)|(1<<3))*/0xFF;
 //PORTD|=/*((1<<1)|(1<<3))*/0xFF;
 //PORTA|=/*((1<<1)|(1<<3))*/0xFF;

 PORTB|= (1<<1); 
 PORTC|= (1<<3)|(1<<1);
 PORTD|= (1<<5); 
 PORTA|= (1<<0)|(1<<1);

 PORTB|=(1<<5)|(1<<4)|(1<<2); // 5 4 2
 PORTC|= (1<<5)|(1<<4)|(1<<2)|(1<<0); // 5 4 2 0 
 PORTD|= (1<<4); // 4 

}

#define	SGA	(1<<0)
#define SGB	(1<<1)
#define SGC	(1<<2)
#define SGD	(1<<3)
#define SGE	(1<<4)
#define SGF	(1<<5)
#define SGG	(1<<6)
#define SGH	(1<<7)


void LedSetSegments(void) {
   unsigned char dec=0;
   unsigned char lastzn;
   
   lastzn=ledtext[muxpos];
   
   if (dotpos==muxpos) {
	dec|=SGH;	
   }

   /// dekoder ///
 			if (lastzn=='[') {
				dec|=SGA+SGD+SGE+SGF;
			}
			if (lastzn==']') {
				dec|=SGA+SGD+SGB+SGC;
			}
			if (lastzn=='S'||lastzn=='5') {
				dec|=SGA+SGC+SGD+SGF+SGG;
			}
			if (lastzn=='-') {
				dec|=SGG;
			}
			if (lastzn=='0') {
				dec|=SGA+SGB+SGC+SGD+SGE+SGF;
			}
			if (lastzn=='1') {
				dec|=SGB+SGC;
			}			
			if (lastzn=='2') {
				dec|=SGA+SGB+SGG+SGE+SGD;
			}			
			if (lastzn=='3') {
				dec|=SGA+SGD+SGG+SGB+SGC;
			}
			if (lastzn=='4') {
				dec|=SGB+SGC+SGG+SGF;
			}
			if (lastzn=='6') {
				dec|=SGA+SGD+SGC+SGG+SGE+SGF;
			}			
			if (lastzn=='7') {
				dec|=SGA+SGB+SGC;
			}			
			if (lastzn=='8') {
				dec|=SGA+SGB+SGC+SGD+SGE+SGF+SGG;
			}
			if (lastzn=='9') {
				dec|=SGA+SGB+SGC+SGD+SGF+SGG;
			}
			if (lastzn=='o') {
				dec|=SGC+SGD+SGE+SGG;
			}
			if (lastzn=='r') {
				dec|=SGE+SGG;
			}
			if (lastzn=='n') {
				dec|=SGC+SGE+SGG;
			}
			if (lastzn=='P') {
				dec|=SGA+SGB+SGE+SGF+SGG;
			}
			if (lastzn=='E') {
				dec|=SGA+SGD+SGG+SGE+SGF;
			}
			if (lastzn=='A') {
				dec|=SGA+SGB+SGC+SGE+SGF+SGG;
			}
			if (lastzn=='d') {
				dec|=SGB+SGC+SGD+SGE+SGG;
			}
			
  /// zobrazeni ///
 
// nastaveni pouzivanych bitu do jednicky
 PORTB|=(1<<5)|(1<<4)|(1<<2); // 5 4 2
 PORTC|= (1<<5)|(1<<4)|(1<<2)|(1<<0); // 5 4 2 0 
 PORTD|= (1<<4); // 4 


  if (muxpos<4) { // velka 7segmentovka
  if (dec&SGA) {PORTC&=~(1<<5);}
  if (dec&SGB) {PORTC&=~(1<<2);}
  if (dec&SGC) {PORTD&=~(1<<4);}
  if (dec&SGD) {PORTB&=~(1<<5);}  
  if (dec&SGE) {PORTC&=~(1<<0);}  
  if (dec&SGF) {PORTC&=~(1<<4);}  
  if (dec&SGG) {PORTB&=~(1<<2);}  
  if (dec&SGH) {PORTB&=~(1<<4);}  
 } else if (muxpos==5) { // ledky

 	if (leds&0x1) {PORTC&=~(1<<5);} // led1 
	if (leds&(0x2)) {PORTC&=~(1<<2);} // led2
	if (leds&(0x4)) {PORTD&=~(1<<4);} // led3
	if (leds&(0x8)) {PORTB&=~(1<<5);} // led4
  
 } else { // mala
  if (dec&SGA) {PORTC&=~(1<<2);}
  if (dec&SGE) {PORTD&=~(1<<4);}
  if (dec&SGG) {PORTB&=~(1<<5);}  
  if (dec&SGF) {PORTC&=~(1<<0);}  
  if (dec&SGB) {PORTC&=~(1<<4);}  
  if (dec&SGD) {PORTB&=~(1<<2);}  
  if (dec&SGC) {PORTC&=~(1<<5);}  

}

}




//prepne multiplex
void LedMuxOne(void) {
	muxpos++;
	if (muxpos==LEDCHARS) {
		muxpos=0;
	};
	LedSwCharOff();
	LedSetSegments();	
	LedSwCharOn();

};


//provede cely cyklus multiplexu a zhasne displej
void LedMux(void) {
 //   unsigned char mux; muxpos=0;	
//	for (mux=0;mux<LEDCHARS;mux++) {LedMuxOne();_delay_us(20);}
//	LedSwCharOff();
LedMuxOne();
//_delay_us(40);
//LedSwCharOff();
}

/*
void LedMuxZvyr(unsigned char id) {
	LedMux();
	if (muxpos==id) {
		DelayMs(2);
	}
}

*/
//zhasne displej
void LedOff(void) {
	LedSwCharOff();
}


//zobrazi cislo 0 - 99999
void LedDispNumber(unsigned long num, unsigned char hidezeros) {
	if (num>99999) {num=99999;};
	
	//ledtext[0]=(num/10000)+'0';
	ledtext[1]=(num/1000)%10+'0';
	ledtext[2]=(num/100)%10+'0';
	ledtext[3]=(num/10)%10+'0';
	ledtext[4]=(num%10)+'0';
	
	if (hidezeros&&num<10000&&dotpos>0) {ledtext[0]=CHAR_BLANK;};
	if (hidezeros&&num<1000&&dotpos>1) {ledtext[1]=CHAR_BLANK;};
	if (hidezeros&&num<100&&dotpos>2) {ledtext[2]=CHAR_BLANK;};
	if (hidezeros&&num<10&&dotpos>3) {ledtext[3]=CHAR_BLANK;};
	
	
}

